#include <stdio.h>
#include <string.h>

#include "L1CrisHskp.h"
#include "df.h"

void main(argc, argv)
int argc;
char *argv[];
{
  int32 hdf_fp, sd_id;
  struct L1CrisHskp testdata;
  int ii,jj,kk,retval;
  int32 numrec;

  if (argc!=2)
    {
      printf("Usage: rd_hdf hdf_file\n");
      exit(1);
    }

  /* open hdf input file */

  if ((hdf_fp=Hopen(argv[1], DFACC_RDONLY, 0))==FAIL)
    {
      fprintf(stderr, "Hopen: could not open hdf file\n");
      exit(-1);
    }
  Vstart(hdf_fp);

  if ((sd_id=SDstart(argv[1], DFACC_RDONLY))==FAIL)
    {
      fprintf(stderr, "SDstart: could not open hdf file\n");
      exit(-1);
    }

  numrec = init_rd_L1CrisHskp(hdf_fp, sd_id, "r");
  if(numrec <= 0) {
      fprintf(stderr,"No cris L1 Hskp data\n");
      exit(-1);
  }

  ii=0;
  while((retval= read_L1CrisHskp(&testdata,ii++))!=FAIL) {
	  printf("ClockCycle = %8d ", testdata.ClockCycle);
          printf("Sec1996  = %10d ", testdata.Second1996);
          printf("CtIndex = %5d ", testdata.CommandTableIndex);
          printf("+5V = %5d\n", testdata.MonitorP5V);
  }

  /* all done, close HDF file */

  close_rd_L1CrisHskp();
  Vend(hdf_fp);
  if (SDend(sd_id)==FAIL)
    {
      fprintf(stderr, "SDend: could not close hdf file\n");
      exit(-1);
    }
  if (Hclose(hdf_fp)==FAIL)
    {
      fprintf(stderr, "Hclose: could not close hdf file\n");
      exit(-1);
    }

  exit(0);
}
    
