/* $Id: s3_dspare_alarm.h,v 1.3 1998/01/30 19:49:30 hemple Exp $ */

#include "hdfi.h"

struct s3s_dspare_alarm {

uint32 sctime; /* 32bit spacecraft time */

/* SEPICA limits for alarm monitoring, from EDB 6 */
uint16 AlarmDelay_set;	/* delay 10 min. */
uint16 AlarmDis;	/* 30kV discharge check */
uint16 AlarmPres;	/* pressure check */
uint16 AlarmLV;		/* LV status bit check */
uint16 AlarmV1Open_set;	/* valve 1 open */
uint16 AlarmV2Open_set;	/* valve 2 open */
uint16 AlarmV3Open_set;	/* valve 3 open */
uint16 AlarmPC1P_min;	/* PC1 pressure */
uint16 AlarmPC1P_max;	/* PC1 pressure */
uint16 AlarmPC2P_min;	/* PC2 pressure */
uint16 AlarmPC2P_max;	/* PC2 pressure */
uint16 AlarmPC3P_min;	/* PC3 pressure */
uint16 AlarmPC3P_max;	/* PC3 pressure */
uint16 AlarmP5V_min;	/* +5V */
uint16 AlarmP5V_max;	/* +5V */
uint16 AlarmP5I_min;	/* +5V (I) */
uint16 AlarmP5I_max;	/* +5V (I) */
uint16 AlarmM5V_min;	/* -5V */
uint16 AlarmM5V_max;	/* -5V */
uint16 AlarmM5I_min;	/* -5V (I) */
uint16 AlarmM5I_max;	/* -5V (I) */
uint16 AlarmP15V_min;	/* +15V */
uint16 AlarmP15V_max;	/* +15V */
uint16 AlarmP15I_min;	/* +15V (I) */
uint16 AlarmP15I_max;	/* +15V (I) */
uint16 AlarmM15V_min;	/* -15V */
uint16 AlarmM15V_max;	/* -15V */
uint16 AlarmM15I_min;	/* -15V (I) */
uint16 AlarmM15I_max;	/* -15V (I) */
uint16 Alarm75V_min;	/* 75V */
uint16 Alarm75V_max;	/* 75V */
uint16 Alarm75I_min;	/* 75V (I) */
uint16 Alarm75I_max;	/* 75V (I) */
uint16 Alarm2kV_min;	/* 2kV */
uint16 Alarm2kV_max;	/* 2kV */
uint16 Alarm2kI_min;	/* 2kV (I) */
uint16 Alarm2kI_max;	/* 2kV (I) */
uint16 Alarm2kAV_min;	/* 2kV A */
uint16 Alarm2kAV_max;	/* 2kV A */
uint16 Alarm2kBV_min;	/* 2kV B */
uint16 Alarm2kBV_max;	/* 2kV B */
uint16 Alarm2kCV_min;	/* 2kV C */
uint16 Alarm2kCV_max;	/* 2kV C */
uint16 Alarm30kV_min;	/* 30kV */
uint16 Alarm30kV_max;	/* 30kV */
uint16 Alarm30kI_min;	/* 30kV (I) */
uint16 Alarm30kI_max;	/* 30kV (I) */
uint16 AlarmDisV_min;	/* 30kV discharge */
uint16 AlarmDisV_max;	/* 30kV discharge */
uint16 AlarmDisI_min;	/* 30kV discharge (I) */
uint16 AlarmDisI_max;	/* 30kV discharge (I) */
};










